/* Copyright (c) IBM Corp. 1992 */
 
#ifndef _IAEQUAL_H
#define _IAEQUAL_H

#include <iglobals.h>
#include <icursor.h>
#include <iacllct.h>

template < class Element >
class IAEqualityCollection : public virtual IACollection < Element > {
public:

  virtual Boolean        contains                    (Element const&) const = 0;

  virtual Boolean        containsAllFrom             (IACollection <Element>
                                               const&) const;

  virtual Boolean        locate                      (Element const&, ICursor&)
                                               const = 0;

  virtual Boolean        locateOrAdd                 (Element const&) = 0;

  virtual Boolean        locateOrAdd                 (Element const&,
                                               ICursor&) = 0;

  virtual Boolean        remove                      (Element const&) = 0;

  virtual INumber        numberOfOccurrences         (Element const&) const = 0;

  virtual Boolean        locateNext                  (Element const&, ICursor&)
                                               const = 0;

  virtual INumber        removeAllOccurrences        (Element const&) = 0;

protected:

  static Boolean isContained (Element const&, void* env);
  static Boolean isNotContained (Element const&, void* env);

};

#ifdef __IBMCPP__
#include <iaequal.c>
#endif

#endif
